Arch Space

From FreeCAD Documentation
This page is a translated version of the page Arch Space and the translation is 4% complete.
Outdated translations are marked like this.

Arch Space

Menyplacering
Arch → Space
Arbetsbänkar
Arch
Standard genväg
S P
Introducerad i version
0.14
Se även
Arch Wall, Arch Structure

Description

The Space tool allows you to define an empty volume, either by basing it on a solid shape, or by defining its boundaries, or a mix of both. If it is based solely on boundaries, the volume is calculated by starting from the bounding box of all the given boundaries, and subtracting the spaces behind each boundary. The Space object always defines a solid volume. The floor area of a space object, calculated by intersecting a horizontal plane at the center of mass of the space volume, can also be displayed.

Space object created from an existing solid object, then two wall faces are added as boundaries.

Usage

  1. Select an existing solid object, or faces on boundary objects.
  2. Invoke the Arch Space command using several methods:
    • Pressing the Arch Space button in the toolbar.
    • Using the S then P keyboard keys
    • Using the Arch → Space entry from the top menu

Limitations

Properties

  • DataBase: The base object, if any (must be a solid)
  • DataBoundaries: A list of optional boundary elements
  • DataArea: The computed floor area of this space
  • DataFinishFloor: The finishing of the floor of this space
  • DataFinishWalls: The finishing of the walls of this space
  • DataFinishCeiling: The finishing of the ceiling of this space
  • DataGroup: Objects that are included inside this space, such as furniture
  • DataSpaceType: The type of this space
  • DataFloorThickness: The thickness of the floor finish
  • DataNumberOfPeople: The number of people who typically occupy this space
  • DataLightingPower: The electric power needed to light this space in Watts
  • DataEquipmentPower: The electric power needed by the equipment of this space in Watts
  • DataAutoPower: If True, Equipment Power will be automatically filled by the equipment included in this space
  • DataConditioning: The type of air conditioning of this space
  • DataInternal: Specifies if this space is internal or external
  • VyText: The text to show. Use $area, $label, $tag, $floor, $walls, $ceiling to insert the respective data
  • VyFontName: The name of the font
  • VyTextColor: The color of the text
  • VyFontSize: The size of the text
  • VyFirstLine: The size of the first line of text (multiplies the font size. 1 = same size, 2 = double size, etc..)
  • VyLineSpacing: The space between the lines of text
  • VyTextPosition: The position of the text. Leave (0,0,0) for automatic position
  • VyTextAlign: The justification of the text
  • VyDecimals: The number of decimals to use for calculated texts
  • VyShowUnit: Show the unit suffix or not

Options

  • To create zones that group several spaces, use an Arch BuildingPart and set its IFC type to "Spatial Zone".
  • The Space object has the same display modes as other Arch and Part objects, with one more, called Footprint, that displays only the bottom face of the space.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The Space tool can be used in macros and from the Python console by using the following function:

Space = makeSpace(objects=None, baseobj=None, name="Space")
  • Creates a Space object from the given objects or baseobj, which can be
    • one document object, in which case it becomes the base shape of the Space object, or
    • a list of selection objects as returned by FreeCADGui.Selection.getSelectionEx(), or
    • a list of tuples (object, subobjectname)

Example:

import FreeCAD, Arch

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 1000
Box.Width = 1000
Box.Height = 1000

Space = Arch.makeSpace(Box)
Space.ViewObject.LineWidth = 2
FreeCAD.ActiveDocument.recompute()

After a space object is created, selected faces can be added to it with the following code:

import FreeCAD, FreeCADGui, Draft, Arch

points = [FreeCAD.Vector(-500, 0, 0), FreeCAD.Vector(1000, 1000, 0)]
Line = Draft.makeWire(points)
Wall = Arch.makeWall(Line, width=150, height=2000)
FreeCAD.ActiveDocument.recompute()

# Select a face of the wall
selection = FreeCADGui.Selection.getSelectionEx()
Arch.addSpaceBoundaries(Space, selection)

Boundaries can also be removed, again by selecting the indicated faces:

selection = FreeCADGui.Selection.getSelectionEx()
Arch.removeSpaceBoundaries(Space, selection)